SystemOrganization addCategory: #ConfigurationOfSpotlight!

Object subclass: #ConfigurationOfSpotlight
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSpotlight'!

!ConfigurationOfSpotlight class methodsFor: 'development support' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSpotlight class methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSpotlight class methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSpotlight class methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSpotlight class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSpotlight class methodsFor: 'loading' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSpotlight class methodsFor: 'loading' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSpotlight class methodsFor: 'loading' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSpotlight class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
project

	^self new project! !

!ConfigurationOfSpotlight class methodsFor: 'development support' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSpotlight methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 1/21/2012 21:42'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #squeakCommon do: [ 
		spec
			blessing: #baseline;
			repository: 'http://www.squeaksource.com/Spotlight'.
			
		spec
			project: 'OCompletion' with: [
				spec
					className: 'ConfigurationOfOCompletion';
					file: 'ConfigurationOfOCompletion';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Keymapping' with: [
				spec
					className: 'ConfigurationOfKeymapping';
					file: 'ConfigurationOfKeymapping';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			package: 'Spotlight' with: [
				spec requires: #('OCompletion' 'Keymapping') ] ]! !

!ConfigurationOfSpotlight methodsFor: 'baselines' stamp: 'EstebanLorenzano 4/15/2012 11:55'!
baseline11: spec
	<version: '1.1-baseline'>

	spec for: #common do: [ 
		spec
			blessing: #baseline;
			repository: 'http://www.squeaksource.com/Spotlight'.
			
		spec
			project: 'Keymapping' with: [
				spec
					className: 'ConfigurationOfKeymapping';
					file: 'ConfigurationOfKeymapping';
					versionString: #stable;
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			package: 'Spotlight' with: [
				spec requires: #('Keymapping') ] ]! !

!ConfigurationOfSpotlight methodsFor: 'baselines' stamp: 'EstebanLorenzano 5/2/2012 11:13'!
baseline12: spec
	<version: '1.2-baseline'>

	spec for: #common do: [ 
		spec
			blessing: #baseline;
			repository: 'http://www.squeaksource.com/Spotlight'.
			
		spec package: 'Spotlight' ]! !

!ConfigurationOfSpotlight methodsFor: 'symbolic versions' stamp: 'EstebanLorenzano 5/2/2012 13:23'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'pharo2.0.x' version: '1.3'.! !

!ConfigurationOfSpotlight methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 14:46'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSpotlight methodsFor: 'symbolic versions' stamp: 'EstebanLorenzano 5/2/2012 13:22'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo1.4.x' version: '1.1'.
	spec for: #'pharo2.0.x' version: '1.3'.! !

!ConfigurationOfSpotlight methodsFor: 'versions' stamp: 'EstebanLorenzano 4/15/2012 11:56'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'Prepared for 1.4'.
		spec author: 'EstebanLorenzano'.
		spec timestamp: '4/15/2012 11:56'.
		
		spec project: 'Keymapping' with: #'stable'.
		spec package: 'Spotlight' with: 'Spotlight-MarianoMartinezPeck.3'. ].
! !

!ConfigurationOfSpotlight methodsFor: 'versions' stamp: 'EstebanLorenzano 5/2/2012 11:19'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec author: 'EstebanLorenzano'.
		spec timestamp: '2 May 2012 11:14:07 am'.
		
		spec package: 'Spotlight' with: 'Spotlight-MarianoMartinezPeck.3'. ].
! !

!ConfigurationOfSpotlight methodsFor: 'versions' stamp: 'EstebanLorenzano 5/2/2012 13:25'!
version13: spec
	<version: '1.3' imports: #('1.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec author: 'EstebanLorenzano'.
		spec timestamp: '2 May 2012 1:20:47 pm'.
		
		spec package: 'Spotlight' with: 'Spotlight-EstebanLorenzano.5' ].
! !
